#target photoshop
/**
 Скрипт, высчитывающий процент заполнения изображения по каждой краске
 (c) Eugeny Borisov, 2008. 
*/


function CalculateFilling(doc) {


var h = doc.height.as('px');
var w = doc.width.as('px');
var size = h*w;
var j = 0;

	var retval = Array();
	var cCount = doc.channels.length;
	var current = 0;
	while (current < cCount) {
	
		var chname = doc.channels[current].name;
		var histogram = doc.channels[current].histogram;
		var percent = 0;
	

		for (j = 0; j < 256; j++) {
			percent += ( histogram[j]/size ) * ( 1 - j/255 );
		}
		percent = 	Math.round(percent*10000) / 10000; 
		retval.push( {name: chname,value:percent*100 	} )	;
		current++;
	}

	return retval;

}

function CalcRetvalString(ArrayOfValues) {
	var retval = String();
	
	var i = ArrayOfValues.length;
	var j = 0;
	while (j < i) {
		var current = ArrayOfValues[j];
		retval = retval + current.name + '\t' + current.value + "%\n";
		j++;
	}
	return retval;
}

var values = CalculateFilling(app.activeDocument)
var str = CalcRetvalString(values);
alert (str  );
